/******************************************************************************/
#include "mtc2type.h"
#include "mtc2ext.h"
/******************************************************************************/
int Simulation()
{
 for(Frame_Cnt=ZERO;Frame_Cnt<MAX_FRAMES;Frame_Cnt++)
 {
  Get_Frame();
  Add_Noise();
  Receive();
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 int cnt;
 double erand48();
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  N1_Val[URADIUS]=erand48(N1_Store);
  N1_Val[UTHETA]=erand48(N2_Store);
  My_Gauss(VARIANCE,N1_Val);
  Sym0[cnt]=Sym0[cnt]+N1_Val[GRAND_0];
  Sym1[cnt]=Sym1[cnt]+N1_Val[GRAND_1];
 }
 return(0);
}
/******************************************************************************/
/*                         Receiver routines.
*******************************************************************************/
int Receive()
{
 Init_Gamma_I_E();
 Init_Le();
 Bcjr();
 Get_Bit_Errors_Dec1();
 return(0);
}
/******************************************************************************/
/*    Initialize the intrinsic and extrinsic values of gamma for decoder 1.
*******************************************************************************/
int Init_Gamma_I_E()
{
 int time,bit;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  for(bit=ZERO;bit<NUM_INPUTS;bit++)
   Compute_Gamma_I(bit,time);
  for(bit=ZERO;bit<NUM_POSS;bit++)
   Compute_Gamma_E(bit,time);
 }
 return(0);
}
/******************************************************************************/
/*      Compute gamma from data bit (intrinsic information) for decoder 1.
*******************************************************************************/
int Compute_Gamma_I(bit,time)
int bit,time;
{
 double sym,x;
 sym=Bit_Map[bit];
 x=sym-Sym0[time];
 x= -x*x*Inv_Twice_Noise_Var;
 Gamma_I[time][bit]=exp(x);
// printf("time:%d bit:%d x:%lf gi:%lf\n",time,bit,x,Gamma_I[time][bit]);
 return(0);
}
/******************************************************************************/
/*     Compute gamma from sum of parity bits (extrinsic information).
*******************************************************************************/
int Compute_Gamma_E(bit,time)
int bit,time;
{
 double sym,x;
 sym=Sum_Parity_Map[bit];
 x=sym-Sym1[time];
 x= -x*x*Inv_Twice_Noise_Var;
 Gamma_E[time][bit]=exp(x);
// printf("time:%d bit:%d x:%lf ge1:%lf\n",time,bit,x,Gamma_E[time][bit]);
 return(0);
}
/******************************************************************************/
/*                Initialize the ratio of the probabilities.
*******************************************************************************/
int Init_Le()
{
 int cnt;
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
  Le[cnt]=1.0;
 return(0);
}
/******************************************************************************/
/*                          The BCJR algorithm.
*******************************************************************************/
int Bcjr()
{
 for(Iter=ZERO;Iter<MAX_ITER;Iter++)
 {
  Dec1_Process();
  if(Iter < (MAX_ITER-ONE))
   Dec2_Process();
 }
 return(0);
}
/******************************************************************************/
/*    Finally compute the number of bit errors in the frame from decoder1.
*******************************************************************************/
int Get_Bit_Errors_Dec1()
{
 int time,detected_bit;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  if(App_P1[time] > App_M1[time])
   detected_bit=ZERO;
  else
   detected_bit=ONE;
  if(detected_bit != Bits[time])
   Ber++;
 }
 return(0);
}
/******************************************************************************/
