/******************************************************************************/
#include "mtc2type.h"
#include "mtc2ext.h"
/******************************************************************************/
/*                   Get the symbol to be transmitted.
*******************************************************************************/
int Get_Frame()
{
 Get_Data_Bits();
 Get_Enc_Iv_Bits();
// Print_Input_Bits();
// Print_Symbols();
 return(0);
}
/******************************************************************************/
/*                          Get the data bits.
*******************************************************************************/
int Get_Data_Bits()
{
 int cnt,bit,enc_bit;
 int rand(void);
 Enc_State=ZERO;                                         /* State at time -1. */
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  bit=Bits[cnt]=rand()&1;
  enc_bit=Trel_Op[Enc_State][bit];      /* Maps to LSB in "Sum_Parity_Map[]". */
  P1[cnt]=enc_bit;
  Enc_State=Trel_NS[Enc_State][bit];                  /* State at time "cnt". */
  Sym0[cnt]=Bit_Map[bit];
  Sym1[cnt]=Bit_Map[enc_bit];           /* Maps to LSB in "Sum_Parity_Map[]". */
 }
 return(0);
}
/******************************************************************************/
/*                   Get the interleaved and encoded bits.
*******************************************************************************/
int Get_Enc_Iv_Bits()
{
 int cnt,bit,enc_bit,iv_inx,parity_1,sum;
 Enc_State=ZERO;
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  iv_inx=De_Iv_Map[cnt];
  bit=Bits[iv_inx];
  enc_bit=Trel_Op[Enc_State][bit];      /* Maps to MSB in "Sum_Parity_Map[]". */
  P2[iv_inx]=enc_bit;
  Enc_State=Trel_NS[Enc_State][bit];
  parity_1=(int)(1.0-Sym1[iv_inx]);
  parity_1=parity_1>>1;
  if((parity_1 != ZERO) && (parity_1 != ONE))
   Error_Mes(5);
  sum=2*enc_bit+parity_1;
//  printf("sym:%lf int:%d p2:%d sum:%d\n",Sym1[iv_inx],parity_1,enc_bit,sum);
  Sym1[iv_inx]=Sum_Parity_Map[sum];
 }
 return(0);
}
/******************************************************************************/
/*                   Print the input bits to both encoders.
*******************************************************************************/
int Print_Input_Bits()
{
 int cnt;
 printf("\t Input bits to 1st encoder:\n\n");
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
  printf("\t Time:%6d Enc1 bit:%d\n",cnt,Bits[cnt]);
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                            Print the symbols.
*******************************************************************************/
int Print_Symbols()
{
 int cnt;
 printf("\t Transmitted symbols:\n\n");
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  printf("\t Time:%6d Sym0:%+lf ",cnt,Sym0[cnt]);
  printf("Sym1:%+lf\n",Sym1[cnt]);
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
