/******************************************************************************/
#include "mtc3type.h"
#include "mtc3ext.h"
/******************************************************************************/
/* Get the extrinsic information and the corresponding probability for
   decoder 1.
*******************************************************************************/
int Get_Ge_Times_Prob_Dec1(time,input,parity_1)
int time,input,parity_1;
{
 int parity_2,sum;
 double prob;
 Ge_Times_Prob=0.0;
 for(parity_2=ZERO;parity_2<NUM_INPUTS;parity_2++)
 {
  sum=2*parity_2+parity_1;
  Ge_Times_Prob=Ge_Times_Prob+Gamma_E[time][sum]*App_Par2[time][parity_2];
 }
 if(input == ZERO)
  prob=Le[time]/(1.0+Le[time]);
 else
  prob=1.0/(1.0+Le[time]);
 Ge_Times_Prob=Ge_Times_Prob*prob;
 return(0);
}
/******************************************************************************/
/*              Get the sum of extrinsic info for decoder 1.
*******************************************************************************/
int Get_Sum_Ge_Dec1(time,parity_1)
int time,parity_1;
{
 int parity_2,sum;
 Sum_Ge=0.0;
 for(parity_2=ZERO;parity_2<NUM_INPUTS;parity_2++)
 {
  sum=2*parity_2+parity_1;
  Sum_Ge=Sum_Ge+Gamma_E[time][sum]*App_Par2[time][parity_2];
 }
 return(0);
}
/******************************************************************************/
/* Get the extrinsic information and the corresponding probability for
   decoder 2.
*******************************************************************************/
int Get_Ge_Times_Prob_Dec2(time,input,parity_2)
int time,input,parity_2;
{
 int iv_inx,parity_1,sum;
 double prob;
 iv_inx=De_Iv_Map[time];
 Ge_Times_Prob=0.0;
 for(parity_1=ZERO;parity_1<NUM_INPUTS;parity_1++)
 {
  sum=2*parity_2+parity_1;
  Ge_Times_Prob=Ge_Times_Prob+Gamma_E[iv_inx][sum]*App_Par1[iv_inx][parity_1];
 }
 if(input == ZERO)
  prob=Le[iv_inx]/(1.0+Le[iv_inx]);
 else
  prob=1.0/(1.0+Le[iv_inx]);
 Ge_Times_Prob=Ge_Times_Prob*prob;
 return(0);
}
/******************************************************************************/
/*              Get the sum of extrinsic info for decoder 2.
*******************************************************************************/
int Get_Sum_Ge_Dec2(time,parity_2)
int time,parity_2;
{
 int parity_1,sum,iv_inx;
 Sum_Ge=0.0;
 iv_inx=De_Iv_Map[time];
 for(parity_1=ZERO;parity_1<NUM_INPUTS;parity_1++)
 {
  sum=2*parity_2+parity_1;
  Sum_Ge=Sum_Ge+Gamma_E[iv_inx][sum]*App_Par1[iv_inx][parity_1];
 }
 return(0);
}
/******************************************************************************/
