/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                        /* No. of bits per frame. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Bit_Cnt;                                             /* Bit count. */
extern int Ber;                                            /* Bit error rate. */
extern int SS_Detect_Error;         /* BER due to symbol-by-symbol detection. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
extern int Enc1_State_T0;                /* Stores encoder 1 state at time 0. */
extern int Enc2_State_T0;                /* Stores encoder 2 state at time 0. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
extern double Sym0[FRAME_SIZE];                               /* Data symbol. */
extern double Sym1[FRAME_SIZE];                             /* Parity symbol. */
extern double Sym2[FRAME_SIZE];                             /* Parity symbol. */
extern double Sym3[FRAME_SIZE];                   /* Interleaved data symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N3_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N4_Store[PN_SIZE];                /* Stores PNS status. */
extern double Inv_Twice_Pred_Var;        /* Inv. of twice the pred. err. var. */
extern double Noise_0;                              /* Gaussian noise seq. 0. */
extern double Noise_1;                              /* Gaussian noise seq. 1. */
extern double Noise_2;                              /* Gaussian noise seq. 2. */
extern double Noise_3;                              /* Gaussian noise seq. 3. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double N2_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double N0_Reg[PRED_MEM_SIZE];        /* Type 1 filter: Noise memory 0. */
extern double N1_Reg[PRED_MEM_SIZE];        /* Type 1 filter: Noise memory 1. */
extern double N2_Reg[PRED_MEM_SIZE];        /* Type 1 filter: Noise memory 2. */
extern double N3_Reg[PRED_MEM_SIZE];        /* Type 1 filter: Noise memory 3. */
extern double Ip_Coeff;                               /* Type 1 numer. coeff. */
extern double Coeff_Array[PRED_MEM_SIZE];      /* Type 1 denom & pred. coeff. */
extern double Filter_Array[FILTER_SIZE];       /* Type 2 filter coefficients. */
extern double F0_Reg[FILTER_SIZE];          /* Type 2 filter: Noise memory 0. */
extern double F1_Reg[FILTER_SIZE];          /* Type 2 filter: Noise memory 1. */
extern double F2_Reg[FILTER_SIZE];          /* Type 2 filter: Noise memory 2. */
extern double F3_Reg[FILTER_SIZE];          /* Type 2 filter: Noise memory 3. */
extern double Auto_Cor[FILTER_SIZE];        /* Autocorrelation of the filter. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
extern int STrel_NS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis nxt state. */
extern int STrel_PS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis prv state. */
extern int STrel_Op[NUM_ST_STATES][NUM_INPUTS];     /* Super trellis outputs. */
extern int STrel_Ip[NUM_ST_STATES][NUM_INPUTS];  /* Inputs leading to states. */
extern int STrel_G_I[NUM_ST_STATES][NUM_INPUTS];               /* Prv inputs. */
extern int STrel_G_E[NUM_ST_STATES][NUM_INPUTS];             /* Prv parities. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Iter;                                        /* Counts iterations. */
extern double Alpha[FRAME_SIZE][NUM_ST_STATES];                    /* Alphas. */
extern double Beta[FRAME_SIZE][NUM_ST_STATES];                      /* Betas. */
extern double Gamma_I_D1[FRAME_SIZE][MOD1_NUM_INPUTS];  /* D1 intrinsic info. */
extern double Gamma_I_D2[FRAME_SIZE][MOD1_NUM_INPUTS];  /* D2 intrinsic info. */
extern double Gamma_E_P1[FRAME_SIZE][MOD1_NUM_INPUTS]; /* Extrinsic info: P1. */
extern double Gamma_E_P2[FRAME_SIZE][MOD1_NUM_INPUTS]; /* Extrinsic info: P2. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
