/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
int SS_Detect_Error;                /* BER due to symbol-by-symbol detection. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
int Enc1_State_T0;                       /* Stores encoder 1 state at time 0. */
int Enc2_State_T0;                       /* Stores encoder 2 state at time 0. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Sym0[FRAME_SIZE];                                      /* Data symbol. */
double Sym1[FRAME_SIZE];                                    /* Parity symbol. */
double Sym2[FRAME_SIZE];                                    /* Parity symbol. */
double Sym3[FRAME_SIZE];                          /* Interleaved data symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
double Inv_Twice_Pred_Var;               /* Inv. of twice the pred. err. var. */
double Noise_0;                                     /* Gaussian noise seq. 0. */
double Noise_1;                                     /* Gaussian noise seq. 1. */
double Noise_2;                                     /* Gaussian noise seq. 2. */
double Noise_3;                                     /* Gaussian noise seq. 3. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N0_Reg[PRED_MEM_SIZE];               /* Type 1 filter: Noise memory 0. */
double N1_Reg[PRED_MEM_SIZE];               /* Type 1 filter: Noise memory 1. */
double N2_Reg[PRED_MEM_SIZE];               /* Type 1 filter: Noise memory 2. */
double N3_Reg[PRED_MEM_SIZE];               /* Type 1 filter: Noise memory 3. */
double Ip_Coeff;                                      /* Type 1 numer. coeff. */
double Coeff_Array[PRED_MEM_SIZE];             /* Type 1 denom & pred. coeff. */
double Filter_Array[FILTER_SIZE];              /* Type 2 filter coefficients. */
double F0_Reg[FILTER_SIZE];                 /* Type 2 filter: Noise memory 0. */
double F1_Reg[FILTER_SIZE];                 /* Type 2 filter: Noise memory 1. */
double F2_Reg[FILTER_SIZE];                 /* Type 2 filter: Noise memory 2. */
double F3_Reg[FILTER_SIZE];                 /* Type 2 filter: Noise memory 3. */
double Auto_Cor[FILTER_SIZE];               /* Autocorrelation of the filter. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
int STrel_NS[NUM_ST_STATES][NUM_INPUTS];          /* Super trellis nxt state. */
int STrel_PS[NUM_ST_STATES][NUM_INPUTS];          /* Super trellis prv state. */
int STrel_Op[NUM_ST_STATES][NUM_INPUTS];            /* Super trellis outputs. */
int STrel_Ip[NUM_ST_STATES][NUM_INPUTS];         /* Inputs leading to states. */
int STrel_G_I[NUM_ST_STATES][NUM_INPUTS];                      /* Prv inputs. */
int STrel_G_E[NUM_ST_STATES][NUM_INPUTS];                    /* Prv parities. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Alpha[FRAME_SIZE][NUM_ST_STATES];                           /* Alphas. */
double Beta[FRAME_SIZE][NUM_ST_STATES];                             /* Betas. */
double Gamma_I_D1[FRAME_SIZE][MOD1_NUM_INPUTS];         /* D1 intrinsic info. */
double Gamma_I_D2[FRAME_SIZE][MOD1_NUM_INPUTS];         /* D2 intrinsic info. */
double Gamma_E_P1[FRAME_SIZE][MOD1_NUM_INPUTS];        /* Extrinsic info: P1. */
double Gamma_E_P2[FRAME_SIZE][MOD1_NUM_INPUTS];        /* Extrinsic info: P2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
