/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
int Enc1_State_T0;                       /* Stores encoder 1 state at time 0. */
int Enc2_State_T0;                       /* Stores encoder 2 state at time 0. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Re_Sym0[FRAME_SIZE];                        /* Re. sym. at enc. 0 o/p. */
double Im_Sym0[FRAME_SIZE];                        /* Im. sym. at enc. 0 o/p. */
double Re_Sym1[FRAME_SIZE];                        /* Re. sym. at enc. 1 o/p. */
double Im_Sym1[FRAME_SIZE];                        /* Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
double Pred_Var;                          /* Final prediction error variance. */
double Inv_Twice_Pred_Var;               /* Inv. of twice the pred. err. var. */
double Re_Noise_0;                                /* Re. noise at enc. 0 o/p. */
double Im_Noise_0;                                /* Im. noise at enc. 0 o/p. */
double Re_Noise_1;                                /* Re. noise at enc. 1 o/p. */
double Im_Noise_1;                                /* Im. noise at enc. 1 o/p. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double Re_Pred_Coeff[NUM_PRED][PRED_SIZE];                /* Re. pred. coeff. */
double Im_Pred_Coeff[NUM_PRED][PRED_SIZE];                /* Im. pred. coeff. */
double Re_Flt[FILTER_SIZE];                       /* Re. filter coefficients. */
double Im_Flt[FILTER_SIZE];                       /* Im. filter coefficients. */
double Re_F0_Reg[FILTER_SIZE];                           /* Re. filter 0 reg. */
double Im_F0_Reg[FILTER_SIZE];                           /* Im. filter 0 reg. */
double Re_F1_Reg[FILTER_SIZE];                           /* Re. filter 1 reg. */
double Im_F1_Reg[FILTER_SIZE];                           /* Im. filter 1 reg. */
double Re_AC[PRED_MEM_SIZE+ONE];              /* Re. autocorr. of the filter. */
double Im_AC[PRED_MEM_SIZE+ONE];              /* Im. autocorr. of the filter. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Inx_To_VG_Tbl;                      /* No. of entries in valid gamma tbl. */
int Valid_Gamma_Inx[VG_TBL_SIZE];           /* Tbl. with valid gamma indices. */
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
int STrel_NS[NUM_ST_STATES][NUM_INPUTS];          /* Super trellis nxt state. */
int STrel_PS[NUM_ST_STATES][NUM_INPUTS];          /* Super trellis prv state. */
int STrel_Op[NUM_ST_STATES][NUM_INPUTS];            /* Super trellis outputs. */
int STrel_Ip[NUM_ST_STATES][NUM_INPUTS];         /* Inputs leading to states. */
int STrel_Inx[NUM_ST_STATES][NUM_INPUTS];                      /* Prv inputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Alpha[FRAME_SIZE][NUM_ST_STATES];                           /* Alphas. */
double Beta[FRAME_SIZE][NUM_ST_STATES];                             /* Betas. */
double *Gamma_Dec1[FRAME_SIZE];                       /* Gamma for decoder 1. */
double *Gamma_Dec2[FRAME_SIZE];                       /* Gamma for decoder 2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
