/******************************************************************************/
#include "tc4type.h"
#include "tc4ext.h"
/******************************************************************************/
/*                         Convert decimal to binary.
*******************************************************************************/
int Decimal_to_Binary(num,array,array_size)
int num,array[],array_size;
{
 int cnt;
 for(cnt=ZERO;cnt<array_size;cnt++)
  array[cnt]=ZERO;
 cnt=ZERO;
 while(num>ZERO)
 {
  if(cnt == array_size)
   Error_Mes(1);
  array[cnt]=num&1;
  num=num>>1;
  cnt++;
 }
 return(0);
}
/******************************************************************************/
/*               Convert the 1s to -1s suitable for xoring.
*******************************************************************************/
int Convert_for_Xor(array,size)
int array[],size;
{
 int cnt;
 for(cnt=ZERO;cnt<size;cnt++)
 {
  if(array[cnt] == ONE)
   array[cnt]= MINUSONE;
 }
 return(0);
}
/******************************************************************************/
/*                Convert the state back to 1s and 0s format.
*******************************************************************************/
int Convert_Back_to_Binary(array,size)
int array[],size;
{
 int cnt;
 for(cnt=ZERO;cnt<size;cnt++)
 {
  if(array[cnt] == MINUSONE)
   array[cnt]=ONE;
 }
 return(0);
}
/******************************************************************************/
/*                    Convert binary array to decimal.
*******************************************************************************/
int Binary_to_Decimal(array,size)
int array[],size;
{
 int cnt,pow,sum;
 sum=ZERO;
 pow=1;
 for(cnt=ZERO;cnt<size;cnt++)
 {
  sum=sum+pow*array[cnt];
  pow=pow<<1;
 }
 return(sum);
}
/******************************************************************************/
/*                        Normalize the alpha values.
*******************************************************************************/
int Normalize_Alpha(time)
int time;
{
 int state;
 double sum;
 sum=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
  sum=sum+Alpha[time][state];
 for(state=ZERO;state<NUM_STATES;state++)
 {
  Alpha[time][state]=Alpha[time][state]/sum;
//printf("It:%d tim:%d st:%d alp:%lf\n",Iter,time,state,Alpha[time][state]);
 }
 return(0);
}
/******************************************************************************/
/*                        Normalize the beta values.
*******************************************************************************/
int Normalize_Beta(time)
int time;
{
 int state;
 double sum;
 sum=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
  sum=sum+Beta[time][state];
 for(state=ZERO;state<NUM_STATES;state++)
 {
  Beta[time][state]=Beta[time][state]/sum;
//printf("It:%d tim:%d st:%d bet:%lf\n",Iter,time,state,Beta[time][state]);
 }
 return(0);
}
/******************************************************************************/
/*                    Print the alpha and beta values.
*******************************************************************************/
int Print_Alpha_Beta()
{
 int cnt;
 for(cnt=ZERO;cnt<NUM_STATES;cnt++)
 {
  printf("\t Iter:%d State:%d Alpha:%lf ",Iter,cnt,Alpha[PRINT_TIME][cnt]);
  printf(" Beta:%lf\n",Beta[PRINT_TIME+ONE][cnt]);
 }
 return(0);
}
/******************************************************************************/
/*       Convert uniform random variables to gaussian random variables.
*******************************************************************************/
int My_Gauss(tvar,tnarry)
double tvar,tnarry[];
{
 double r,theta;
 r= -2.0*tvar*log(1.0-tnarry[URADIUS]);
 if(r < FRAC_ZERO)
  Error_Mes(10);
 r=sqrt(r);
 theta=2.0*MY_PI*tnarry[UTHETA];
 tnarry[GRAND_0]=r*cos(theta);
 tnarry[GRAND_1]=r*sin(theta);
 return(0);
}
/******************************************************************************/
/*                 Check for memory allocation failure.
*******************************************************************************/
int Ck_Calloc(tmp)
void *tmp;
{
 if(tmp==NULL)
  Error_Mes(5);
 return(0);
}
/******************************************************************************/
/*                             Error message.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 fprintf(stdout,"\t Simulation error. Exiting with code %d.\n\n",num);
 exit(num);
 return(0);
}
/******************************************************************************/
