/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
int Enc1_State_T0;                       /* Stores encoder 1 state at time 0. */
int Enc2_State_T0;                       /* Stores encoder 2 state at time 0. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Sym0[FRAME_SIZE];                                      /* Data symbol. */
double Sym1[FRAME_SIZE];                                    /* Parity symbol. */
double Sym2[FRAME_SIZE];                                    /* Parity symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE][NUM_STATES];                                /* Betas. */
double Gamma_I[FRAME_SIZE][NUM_INPUTS];                /* Dv. intrinsic info. */
double Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P1. */
double Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
