/******************************************************************************/
#include "tc5ctype.h"
#include "tc5cext.h"
/******************************************************************************/
/*                          Check the variables.
*******************************************************************************/
int Ck_Var()
{
 Ck_Max_Frames();
 Ck_Collect_End();
 Ck_Ip_Constell_Size();
 Ck_Tx_Constell_Size();
 Ck_Sys_Delay();
 Ck_Num_States();
 Ck_Pred_Num_States();
 Ck_Super_Trellis_States();
 Ck_Modified_Inputs();
 Ck_Print_Time();
 return(0);
}
/******************************************************************************/
/*             Check the maximum number of frames to be simulated.
*******************************************************************************/
int Ck_Max_Frames()
{
 if(MAX_FRAMES < TRN_FRAMES)
  Error_Mes(20);
 return(0);
}
/******************************************************************************/
/*                  Check the time to stop collecting data.
*******************************************************************************/
int Ck_Collect_End()
{
 if(COLLECT_END >= TWO*FRAME_SIZE)
  Error_Mes(21);
 return(0);
}
/******************************************************************************/
/*                    Check the input constellation size.
*******************************************************************************/
int Ck_Ip_Constell_Size()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<IP_BITS_PER_SYM;cnt++)
  pow=pow*2;
 if(IP_CONSTELL_SIZE != pow)
  Error_Mes(16);
 return(0);
}
/******************************************************************************/
/*                Check the transmitted constellation size.
*******************************************************************************/
int Ck_Tx_Constell_Size()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  pow=pow*2;
 if(CONSTELL_SIZE != pow)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*                         Check the system delay.
*******************************************************************************/
int Ck_Sys_Delay()
{
 if((SYS_DELAY%TWO)!=ZERO)
  Error_Mes(17);
 if(SYS_DELAY <= CHAN_SIZE)
  Error_Mes(18);
 return(0);
}
/******************************************************************************/
/*                       Check the number of states.
*******************************************************************************/
int Ck_Num_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<MEM_SIZE;cnt++)
  pow=pow*2;
 if(NUM_STATES != pow)
  Error_Mes(3);
 return(0);
}
/******************************************************************************/
/*                   Check the number of predictor states.
*******************************************************************************/
int Ck_Pred_Num_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  pow=pow*IP_CONSTELL_SIZE;
 if(NUM_PRED_STATES != pow)
  Error_Mes(6);
 return(0);
}
/******************************************************************************/
/*                 Check the number of super trellis states.
*******************************************************************************/
int Ck_Super_Trellis_States()
{
 if((NUM_STATES*NUM_PRED_STATES) != NUM_ST_STATES)
  Error_Mes(7);
 return(0);
}
/******************************************************************************/
/*                 Check the modified number of inputs.
*******************************************************************************/
int Ck_Modified_Inputs()
{
 if(MOD1_NUM_INPUTS != (NUM_INPUTS*NUM_PRED_STATES))
  Error_Mes(9);
 return(0);
}
/******************************************************************************/
/*                         Check the print time.
*******************************************************************************/
int Ck_Print_Time()
{
 if((PRINT_TIME<ZERO) || (PRINT_TIME>(FRAME_SIZE-2)))
  Error_Mes(4);
 return(0);
}
/******************************************************************************/
