/******************************************************************************/
#include "tc5ctype.h"
#include "tc5cext.h"
/******************************************************************************/
int Initialize_Predictor()
{
 Get_Autocorr();
 Levinson_Durbin();
 Inv_Twice_Pred_Var=1.0/(2.0*Pred_Var);
 printf("\t Inv. of twice the pred. variance:%lf\n\n",Inv_Twice_Pred_Var);
 Print_Norm_Eq();
 return(0);
}
/******************************************************************************/
/*                    Get the autocorrelation of the error.
*******************************************************************************/
int Get_Autocorr()
{
 int cnt,inx,size;
 double re_mf[DATA_SIZE],im_mf[DATA_SIZE];
 double re_op[2*DATA_SIZE-ONE],im_op[2*DATA_SIZE-ONE];
 size=DATA_SIZE;
 Copy_Rev_Conjugate(Re_Err_Reg,Im_Err_Reg,re_mf,im_mf,size);
 Convolve(Re_Err_Reg,Im_Err_Reg,re_mf,im_mf,re_op,im_op,size,size);
 for(cnt=DATA_SIZE-ONE;cnt<=DATA_SIZE-ONE+PRED_MEM_SIZE;cnt++)
 {
  inx=cnt-DATA_SIZE+ONE;
  Re_AC[inx]=re_op[cnt]/(double)(DATA_SIZE-inx);
  Im_AC[inx]=im_op[cnt]/(double)(DATA_SIZE-inx);
  printf("\t Inx:%d ReAC::%lf ImAC:%lf\n",inx,Re_AC[inx],Im_AC[inx]);
 }
 return(0);
}
/******************************************************************************/
/*               Print the normalized equalizer coefficients.
*******************************************************************************/
int Print_Norm_Eq()
{
 int cnt;
 double energy,fac;
 energy=0.0;
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
 {
  energy=energy+Re_Eq[cnt]*Re_Eq[cnt];
  energy=energy+Im_Eq[cnt]*Im_Eq[cnt];
 }
 fac=1.0/sqrt(energy);
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
  fprintf(fp4,"%lf %lf\n",fac*Im_Eq[cnt],fac*Re_Eq[cnt]);
 return(0);
}
/******************************************************************************/
