/******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4;                            /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                        /* No. of bits per frame. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Bit_Cnt;                                             /* Bit count. */
extern int Ber;                                            /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Re_Map[CONSTELL_SIZE];            /* Re. part of constellation. */
extern double Im_Map[CONSTELL_SIZE];            /* Im. part of constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
extern double Re_Sym0[FRAME_SIZE];                 /* Re. sym. at enc. 0 o/p. */
extern double Im_Sym0[FRAME_SIZE];                 /* Im. sym. at enc. 0 o/p. */
extern double Re_Sym1[FRAME_SIZE];                 /* Re. sym. at enc. 1 o/p. */
extern double Im_Sym1[FRAME_SIZE];                 /* Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
extern double Re_Ch_Op;                                   /* Re. channel o/p. */
extern double Im_Ch_Op;                                   /* Im. channel o/p. */
extern double Re_Ch[CHAN_SIZE];                         /* Re. channel coeff. */
extern double Im_Ch[CHAN_SIZE];                         /* Im. channel coeff. */
extern double Re_Ch_Reg[CHAN_SIZE];                    /* Re. channel memory. */
extern double Im_Ch_Reg[CHAN_SIZE];                    /* Im. channel memory. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double N_Var;                                       /* Noise variance. */
extern double Inv_Twice_Var;               /* Inv. of twice the eq. err. var. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*                            EQUALIZER VARIABLES.
*******************************************************************************/
extern double Ip_Pow;                 /* Instantaneous equalizer input power. */
extern double Step;                                             /* Step size. */
extern double Re_Grad;                               /* Re. part of gradient. */
extern double Im_Grad;                               /* Im. part of gradient. */
extern double Re_Eq_Op;                                 /* Re. equalizer o/p. */
extern double Im_Eq_Op;                                 /* Im. equalizer o/p. */
extern double Re_Eq_Err;                              /* Re. equalizer error. */
extern double Im_Eq_Err;                              /* Im. equalizer error. */
extern double Re_Eq[EQ_SIZE];                         /* Re. equalizer coeff. */
extern double Im_Eq[EQ_SIZE];                         /* Im. equalizer coeff. */
extern double Re_Eq_Reg[EQ_SIZE];                       /* Re. equalizer mem. */
extern double Im_Eq_Reg[EQ_SIZE];                       /* Im. equalizer mem. */
/******************************************************************************/
/*                        ERROR REGISTER VARIABLES.
*******************************************************************************/
extern int Err_Reg_Inx;                           /* Index to error register. */
extern double Re_Err_Reg[DATA_SIZE];                /* Re. eq. error samples. */
extern double Im_Err_Reg[DATA_SIZE];                /* Im. eq. error samples. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                            RECEIVED SYMBOLS.
*******************************************************************************/
extern double Rx_Re_Sym0[FRAME_SIZE];          /* Rx. Re. sym. at enc. 0 o/p. */
extern double Rx_Im_Sym0[FRAME_SIZE];          /* Rx. Im. sym. at enc. 0 o/p. */
extern double Rx_Re_Sym1[FRAME_SIZE];          /* Rx. Re. sym. at enc. 1 o/p. */
extern double Rx_Im_Sym1[FRAME_SIZE];          /* Rx. Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Iter;                                        /* Counts iterations. */
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE][NUM_STATES];                         /* Betas. */
extern double Gamma_Dec1[FRAME_SIZE][NUM_GAMMA_INX];  /* Gamma for decoder 1. */
extern double Gamma_Dec2[FRAME_SIZE][NUM_GAMMA_INX];  /* Gamma for decoder 2. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
