/******************************************************************************/
FILE *fp1,*fp2,*fp3,*fp4;                                   /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Re_Map[CONSTELL_SIZE];                   /* Re. part of constellation. */
double Im_Map[CONSTELL_SIZE];                   /* Im. part of constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Re_Sym0[FRAME_SIZE];                        /* Re. sym. at enc. 0 o/p. */
double Im_Sym0[FRAME_SIZE];                        /* Im. sym. at enc. 0 o/p. */
double Re_Sym1[FRAME_SIZE];                        /* Re. sym. at enc. 1 o/p. */
double Im_Sym1[FRAME_SIZE];                        /* Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
double Re_Ch_Op;                                          /* Re. channel o/p. */
double Im_Ch_Op;                                          /* Im. channel o/p. */
double Re_Ch[CHAN_SIZE];                                /* Re. channel coeff. */
double Im_Ch[CHAN_SIZE];                                /* Im. channel coeff. */
double Re_Ch_Reg[CHAN_SIZE];                           /* Re. channel memory. */
double Im_Ch_Reg[CHAN_SIZE];                           /* Im. channel memory. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double N_Var;                                              /* Noise variance. */
double Inv_Twice_Var;                      /* Inv. of twice the eq. err. var. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                            EQUALIZER VARIABLES.
*******************************************************************************/
double Ip_Pow;                        /* Instantaneous equalizer input power. */
double Step;                                                    /* Step size. */
double Re_Grad;                                      /* Re. part of gradient. */
double Im_Grad;                                      /* Im. part of gradient. */
double Re_Eq_Op;                                        /* Re. equalizer o/p. */
double Im_Eq_Op;                                        /* Im. equalizer o/p. */
double Re_Eq_Err;                                     /* Re. equalizer error. */
double Im_Eq_Err;                                     /* Im. equalizer error. */
double Re_Eq[EQ_SIZE];                                /* Re. equalizer coeff. */
double Im_Eq[EQ_SIZE];                                /* Im. equalizer coeff. */
double Re_Eq_Reg[EQ_SIZE];                              /* Re. equalizer mem. */
double Im_Eq_Reg[EQ_SIZE];                              /* Im. equalizer mem. */
/******************************************************************************/
/*                        ERROR REGISTER VARIABLES.
*******************************************************************************/
int Err_Reg_Inx;                                  /* Index to error register. */
double Re_Err_Reg[DATA_SIZE];                       /* Re. eq. error samples. */
double Im_Err_Reg[DATA_SIZE];                       /* Im. eq. error samples. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                            RECEIVED SYMBOLS.
*******************************************************************************/
double Rx_Re_Sym0[FRAME_SIZE];                 /* Rx. Re. sym. at enc. 0 o/p. */
double Rx_Im_Sym0[FRAME_SIZE];                 /* Rx. Im. sym. at enc. 0 o/p. */
double Rx_Re_Sym1[FRAME_SIZE];                 /* Rx. Re. sym. at enc. 1 o/p. */
double Rx_Im_Sym1[FRAME_SIZE];                 /* Rx. Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE][NUM_STATES];                                /* Betas. */
double Gamma_Dec1[FRAME_SIZE][NUM_GAMMA_INX];         /* Gamma for decoder 1. */
double Gamma_Dec2[FRAME_SIZE][NUM_GAMMA_INX];         /* Gamma for decoder 2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
