/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*             Compute the final APP ratios in the last iteration.
*******************************************************************************/
int Compute_Final_APPs_Dec1()
{
 int time;
 double fapp[NUM_INPUTS];
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  Get_Final_APP_Dec1(time,fapp);
  Get_Final_Prob_Dec1(time,fapp);
 }
 return(0);
}
/******************************************************************************/
/*      Get the final unnormalized probabilities in deinterleaved format.
*******************************************************************************/
int Get_Final_APP_Dec1(time,fapp)
int time;
double fapp[];
{
 int state,input,nxt_state,op;
 double ge,gi,prob,nxt_beta,prv_alpha;
 fapp[ZERO]=fapp[ONE]=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
 {
  for(input=ZERO;input<NUM_INPUTS;input++)
  {
   nxt_state=Trel_NS[state][input];
   op=Trel_Op[state][input];
   ge=Gamma_E_P1[time][op];                         /* Corresponds to parity. */
   gi=Gamma_I[time][input];                           /* Corresponds to data. */
   prob=Prob[time][input];
   prv_alpha=nxt_beta=1.0;
   if(time > ZERO)
    prv_alpha=Alpha[time-ONE][state];
   if(time < (FRAME_SIZE-ONE))
    nxt_beta=Beta[time+ONE][nxt_state];
   fapp[input]=fapp[input]+ge*gi*prv_alpha*nxt_beta*prob;
  }
 }
 return(0);
}
/******************************************************************************/
/*     Get the final unnormalized probabilities in deinterleaved format.
*******************************************************************************/
int Get_Final_Prob_Dec1(time,fapp)
int time;
double fapp[];
{
 int input;
 for(input=ZERO;input<NUM_INPUTS;input++)
  Prob[time][input]=fapp[input];
 return(0);
}
/******************************************************************************/
