/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*               Find locations of 1s and 0s in parity bits.
*******************************************************************************/
int Find_Parity_Locations()
{
 int sum1,sum2;
 Get_P1_Locations();
 Get_P2_Locations();
// Print_Hard_Decisions();
// sum1=P1_Bit0_Cnt+P1_Bit1_Cnt;
// sum2=P2_Bit0_Cnt+P2_Bit1_Cnt;
// printf("p1 bit0:%d bit1:%d sum1:%d\n",P1_Bit0_Cnt,P1_Bit1_Cnt,sum1);
// printf("p2 bit0:%d bit1:%d sum2:%d\n",P2_Bit0_Cnt,P2_Bit1_Cnt,sum2);
 return(0);
}
/******************************************************************************/
/*                  Get locations of 1s and 0s in parity 1.
*******************************************************************************/
int Get_P1_Locations()
{
 int time;
 P1_Bit0_Cnt=P1_Bit1_Cnt=ZERO;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  if(((time%2) == P1_EXISTS) && (Parity1[time] == ZERO))
  {
   P1_Bit0_Loc[P1_Bit0_Cnt]=time;
   P1_Bit0_Cnt++;
  }
  if(((time%2) == P1_EXISTS) && (Parity1[time] == ONE))
  {
   P1_Bit1_Loc[P1_Bit1_Cnt]=time;
   P1_Bit1_Cnt++;
  }
 }
 return(0);
}
/******************************************************************************/
/*                       Get parity 2 hard decisions.
*******************************************************************************/
int Get_P2_Locations()
{
 int time;
 P2_Bit0_Cnt=P2_Bit1_Cnt=ZERO;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  if(((time%2) != P1_EXISTS) && (Parity2[time] == ZERO))
  {
   P2_Bit0_Loc[P2_Bit0_Cnt]=time;
   P2_Bit0_Cnt++;
  }
  if(((time%2) != P1_EXISTS) && (Parity2[time] == ONE))
  {
   P2_Bit1_Loc[P2_Bit1_Cnt]=time;
   P2_Bit1_Cnt++;
  }
 }
 return(0);
}
/******************************************************************************/
/*                           Print hard decisions.
*******************************************************************************/
int Print_Hard_Decisions()
{
 Print_P1_Hard_Decisions();
 Print_P2_Hard_Decisions();
 return(0);
}
/******************************************************************************/
/*                    Print parity 1 hard decisions.
*******************************************************************************/
int Print_P1_Hard_Decisions()
{
 int cnt,loc;
 for(cnt=ZERO;cnt<P1_Bit0_Cnt;cnt++)
 {
  loc=P1_Bit0_Loc[cnt];
  printf("\t P1 bit0 index:%5d loc:%5d act parity:%d\n",cnt,loc,Parity1[loc]);
 }
 printf("\n");
 for(cnt=ZERO;cnt<P1_Bit1_Cnt;cnt++)
 {
  loc=P1_Bit1_Loc[cnt];
  printf("\t P1 bit1 index:%5d loc:%5d act parity:%d\n",cnt,loc,Parity1[loc]);
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                    Print parity 2 hard decisions.
*******************************************************************************/
int Print_P2_Hard_Decisions()
{
 int cnt,loc;
 for(cnt=ZERO;cnt<P2_Bit0_Cnt;cnt++)
 {
  loc=P2_Bit0_Loc[cnt];
  printf("\t P2 bit0 index:%5d loc:%5d act parity:%d\n",cnt,loc,Parity2[loc]);
 }
 printf("\n");
 for(cnt=ZERO;cnt<P2_Bit1_Cnt;cnt++)
 {
  loc=P2_Bit1_Loc[cnt];
  printf("\t P2 bit1 index:%5d loc:%5d act parity:%d\n",cnt,loc,Parity2[loc]);
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
