/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Noise_Gen_Init();
 Iv_Noise_Gen_Init();
 Ber_Init();
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int cnt;
 int random(void);
 for(cnt=ZERO;cnt<PN_SIZE;cnt++)
 {
  N1_Store[cnt]=(unsigned short)random();
  N2_Store[cnt]=(unsigned short)random();
  N3_Store[cnt]=(unsigned short)random();
  N4_Store[cnt]=(unsigned short)random();
  N5_Store[cnt]=8719+cnt;
  N6_Store[cnt]=2543+cnt;
 }
 Inv_Twice_Noise_Var=1.0/(2.0*VARIANCE);
 return(0);
}
/******************************************************************************/
/*                Initialize the interleaver noise generator.
*******************************************************************************/
int Iv_Noise_Gen_Init()
{
 Iv_Noise_Store[0]=15131;
 Iv_Noise_Store[1]=13111;
 Iv_Noise_Store[2]=10591;
 return(0);
}
/******************************************************************************/
/*                       Initialize the bit error rate.
*******************************************************************************/
int Ber_Init()
{
 P1_Error=P2_Error=Ber=Fer=ZERO;
 return(0);
}
/******************************************************************************/
