/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
int Get_Parity_Ivs()
{
 int ck_iv_inx[IV_SIZE>>1],piv_map[IV_SIZE>>1];
 double iv_noise_val[IV_SIZE>>1];
 Get_P1_Bit0_Iv(piv_map,ck_iv_inx,iv_noise_val);
 Get_P1_Bit1_Iv(piv_map,ck_iv_inx,iv_noise_val);
 Get_P2_Bit0_Iv(piv_map,ck_iv_inx,iv_noise_val);
 Get_P2_Bit1_Iv(piv_map,ck_iv_inx,iv_noise_val);
// Copy_Est_Gamma_to_Gamma();
 return(0);
}
/******************************************************************************/
/*               Get the interleaver map for parity 1 bit 0s.
*******************************************************************************/
int Get_P1_Bit0_Iv(piv_map,ck_iv_inx,iv_noise_val)
int piv_map[],ck_iv_inx[];
double iv_noise_val[];
{
 Get_Uniform_Noise(iv_noise_val,P1_Bit0_Cnt);
 Init_Ck_Iv_Inx(ck_iv_inx,P1_Bit0_Cnt);
 Get_Parity_Iv_Elements(iv_noise_val,ck_iv_inx,P1_Bit0_Cnt,piv_map);
// Print_Parity_Iv_Map(piv_map,P1_Bit0_Cnt,1,0);
 Interleave(Est_Gamma_E_P1,Gamma_E_P1,piv_map,P1_Bit0_Cnt,0,P1_Bit0_Loc);
 return(0);
}
/******************************************************************************/
/*               Get the interleaver map for parity 1 bit 1s.
*******************************************************************************/
int Get_P1_Bit1_Iv(piv_map,ck_iv_inx,iv_noise_val)
int piv_map[],ck_iv_inx[];
double iv_noise_val[];
{
 Get_Uniform_Noise(iv_noise_val,P1_Bit1_Cnt);
 Init_Ck_Iv_Inx(ck_iv_inx,P1_Bit1_Cnt);
 Get_Parity_Iv_Elements(iv_noise_val,ck_iv_inx,P1_Bit1_Cnt,piv_map);
// Print_Parity_Iv_Map(piv_map,P1_Bit1_Cnt,1,1);
 Interleave(Est_Gamma_E_P1,Gamma_E_P1,piv_map,P1_Bit1_Cnt,1,P1_Bit1_Loc);
 return(0);
}
/******************************************************************************/
/*               Get the interleaver map for parity 2 bit 0s.
*******************************************************************************/
int Get_P2_Bit0_Iv(piv_map,ck_iv_inx,iv_noise_val)
int piv_map[],ck_iv_inx[];
double iv_noise_val[];
{
 Get_Uniform_Noise(iv_noise_val,P2_Bit0_Cnt);
 Init_Ck_Iv_Inx(ck_iv_inx,P2_Bit0_Cnt);
 Get_Parity_Iv_Elements(iv_noise_val,ck_iv_inx,P2_Bit0_Cnt,piv_map);
// Print_Parity_Iv_Map(piv_map,P2_Bit0_Cnt,2,0);
 Interleave(Est_Gamma_E_P2,Gamma_E_P2,piv_map,P2_Bit0_Cnt,0,P2_Bit0_Loc);
 return(0);
}
/******************************************************************************/
/*               Get the interleaver map for parity 2 bit 1s.
*******************************************************************************/
int Get_P2_Bit1_Iv(piv_map,ck_iv_inx,iv_noise_val)
int piv_map[],ck_iv_inx[];
double iv_noise_val[];
{
 Get_Uniform_Noise(iv_noise_val,P2_Bit1_Cnt);
 Init_Ck_Iv_Inx(ck_iv_inx,P2_Bit1_Cnt);
 Get_Parity_Iv_Elements(iv_noise_val,ck_iv_inx,P2_Bit1_Cnt,piv_map);
// Print_Parity_Iv_Map(piv_map,P2_Bit1_Cnt,2,1);
 Interleave(Est_Gamma_E_P2,Gamma_E_P2,piv_map,P2_Bit1_Cnt,1,P2_Bit1_Loc);
 return(0);
}
/******************************************************************************/
/*      Copy the estimated extrinsic info to the extrinsic info array.
*******************************************************************************/
int Copy_Est_Gamma_to_Gamma()
{
 int time;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  if((time%2) != P1_EXISTS)
  {
   Gamma_E_P1[time][ZERO]=Est_Gamma_E_P1[time][ZERO];
   Gamma_E_P1[time][ONE] =Est_Gamma_E_P1[time][ONE];
  }
  if((time%2) == P1_EXISTS)
  {
   Gamma_E_P2[time][ZERO]=Est_Gamma_E_P2[time][ZERO];
   Gamma_E_P2[time][ONE] =Est_Gamma_E_P2[time][ONE];
  }
 }
 return(0);
}
/******************************************************************************/
