/******************************************************************************/
#include "tc7ctype.h"
#include "tc7cext.h"
/******************************************************************************/
/*             Compute the final APP ratios in the last iteration.
*******************************************************************************/
int Compute_Final_APPs_Dec1()
{
 int time;
 double fapp[NUM_INPUTS];
 for(time=PRED_MEM_SIZE;time<FRAME_SIZE;time++)
 {
  Get_Final_APP_Dec1(time,fapp);
  Get_Final_Prob_Dec1(time,fapp);
 }
 return(0);
}
/******************************************************************************/
/*      Get the final unnormalized probabilities in deinterleaved format.
*******************************************************************************/
int Get_Final_APP_Dec1(time,fapp)
int time;
double fapp[];
{
 int state,input,nxt_state,g_inx;
 double g,prob,nxt_beta,prv_alpha;
 fapp[ZERO]=fapp[ONE]=0.0;
 for(state=ZERO;state<NUM_ST_STATES;state++)
 {
  for(input=ZERO;input<NUM_INPUTS;input++)
  {
   nxt_state=STrel_NS[state][input];
   g_inx=STrel_Inx[state][input];
   g=Gamma_Dec1[time][g_inx];
   prob=Prob[time][input];
   prv_alpha=nxt_beta=1.0;
   if(time > PRED_MEM_SIZE)
    prv_alpha=Alpha[time][state];
   if(time < (FRAME_SIZE-ONE))
    nxt_beta=Beta[time+ONE][nxt_state];
   fapp[input]=fapp[input]+g*prv_alpha*nxt_beta*prob;
  }
 }
 return(0);
}
/******************************************************************************/
/*     Get the final unnormalized probabilities in deinterleaved format.
*******************************************************************************/
int Get_Final_Prob_Dec1(time,fapp)
int time;
double fapp[];
{
 int input;
 double sum;
 sum=0.0;
 for(input=ZERO;input<NUM_INPUTS;input++)
  sum=sum+fapp[input];
 for(input=ZERO;input<NUM_INPUTS;input++)
  Prob[time][input]=fapp[input]/sum;
 return(0);
}
/******************************************************************************/
